Index: doc/ChangeLog
from  Reda Dehak  <reda@lrde.epita.fr>

	* doc/dev/thanks.texi: Rewording.
	* doc/dev/abstract.texi: Change olena web page adresse.
	* doc/dev/oln-dev.texi, doc/dev/build.texi,
	doc/dev/install.texi, doc/dev/faq.texi,
	doc/dev/srctree.texi, doc/dev/conf.texi: Spell checking.

Index: doc/dev/oln-dev.texi
--- doc/dev/oln-dev.texi Tue, 26 Aug 2003 14:20:31 +0200 djo (oln/j/1_oln-dev.te 1.6.1.5 600)
+++ doc/dev/oln-dev.texi Wed, 12 May 2004 10:25:47 +0200 reda (oln/j/1_oln-dev.te 1.6.1.5 600)
@@ -108,7 +108,7 @@
 @chapter Credits
 
 @menu
-* Aknowledgements::
+* Acknowledgements::
 * Bibliography::
 @end menu
 
Index: doc/dev/thanks.texi
--- doc/dev/thanks.texi Thu, 15 Apr 2004 17:39:38 +0200 palma_g (oln/p/40_thanks.tex 1.7 600)
+++ doc/dev/thanks.texi Wed, 12 May 2004 11:05:44 +0200 reda (oln/p/40_thanks.tex 1.7 600)
@@ -1,7 +1,7 @@
 @documentencoding ISO-8859-1
 
-@node Aknowledgements
-@section Aknowledgements
+@node Acknowledgements
+@section Acknowledgements
 
 The following people contributed to Olena, maybe indirectly through
 one of the numerous prototypes Olena has uprisen from. Olena would not
@@ -10,175 +10,192 @@
 @table @sc
 @item Thierry G@'eraud
 @itemize @minus
-@item for managing the project in the first place,
-@item for his work on the type system,
-@item for his numerous hours spent thinking about Olena.
+@item management of the project in the first place,
+@item type system,
+@item numerous hours spent thinking about Olena.
 @end itemize
 
 @item Alexandre Duret-Lutz
 @itemize @minus
-@item for having maintained the source tree for several years,
-@item for his work on the type system,
-@item for his work on the test system,
-@item for his work on the documentation system,
-@item for his numerous hours spent on Olena to make it better.
+@item maintenance of the source tree for several years,
+@item type system,
+@item test system,
+@item first documentation system,
+@item numerous hours spent on Olena to make it better.
 @end itemize
 
 @item Reda Dehak
 @itemize @minus
-@item for managing the project,
-@item for his work on the color conversions,
-@item for his contributions to cleanup the sources.
+@item management of the project,
+@item color conversions,
+@item cleanup the sources.
 @end itemize
 
 @item Akim Demaille
 @itemize @minus
-@item for his help with the configuration system,
-@item for his help to keep things clean.
+@item configuration system.
+@item maintenance of code's clearness.
 @end itemize
 
 @item Anthony Pinagot
 @itemize @minus
-@item for his work on Olena I/O,
-@item for his work on statistical operators,
-@item for his study on the FFT.
+@item Olena I/O,
+@item statistical operators,
+@item FFT algorithm.
 @end itemize
 
 @item Astrid Wang
 @itemize @minus
-@item for her work on new documentation system,
-@item for her work on static arrays.
+@item new documentation system,
+@item static arrays implementation.
 @end itemize
 
 @item Damien Thivolle
 @itemize @minus
-@item for his contributions to document the code,
-@item for his work on generic morphers,
-@item for his work on the configuration system.
+@item contributions to document the code,
+@item generic morphers,
+@item configuration system.
 @end itemize
 
 @item David Lesage
 @itemize @minus
-@item for his work on the type system,
-@item for his work on the new paradigm,
-@item for his contributions to cleanup the sources.
+@item type system,
+@item new paradigm,
+@item cleanup the sources.
 @end itemize
 
 @item Dimitri Papadopoulos-Orfanos
-for his work on the type system
+@itemize @minus
+@item  type system
+@end itemize
+
 
 @item Emmanuel Turquin
 @itemize @minus
-@item for implementing transforms,
-@item for his work on integre.
+@item implementation of transforms,
+@item integre.
 @end itemize
 
 @item Giovanni Palma
 @itemize @minus
-@item for his work on color conversion,
-@item for his work on attribute opening and closing algorithms,
-@item for his work on new documentation system,
-@item for his contributions to document the code,
-@item for his contributions to cleanup the sources.
+@item color conversion,
+@item attribute opening and closing algorithms,
+@item new documentation system,
+@item document the code,
+@item cleanup the sources.
 @end itemize
 
 @item Heru Xue
-for his work on the color system.
+@itemize @minus
+@item color system.
+@end itemize
 
 @item Ignacy Gawedzki
-for his work on the color system.
+@itemize @minus
+@item color system.
+@end itemize
+
 
 @item Jean Chalard
 @itemize @minus
-@item for his work on colors,
-@item for implementing vectors and matrices,
-@item for implementing Olena iterators,
-@item for his study of wavelets.
+@item colors,
+@item vectors and matrices implementation,
+@item Olena iterators implementation,
+@item wavelets.
 @end itemize
 
 @item Jean-S@'ebastien Mouret
 @itemize @minus
-@item for his work on image I/O,
-@item for his work on the source tree and configuration system,
-@item for his work on fast morphological operators.
+@item image I/O,
+@item source tree and configuration system,
+@item fast morphological operators.
 @end itemize
 
 @item J@'er@^ome Darbon
-for his work on image morphology and Olena morpho.
+@itemize @minus
+@item image morphology and Olena morpho.
+@end itemize
 
 @item Ludovic Perrine
-for his study of fuzzy types.
+@itemize @minus
+@item fuzzy types.
+@end itemize
 
 @item Micha@"el Strauss
 @itemize @minus
-@item for his work on image morphology,
-@item for his work on the watershed algorithms,
-@item for his work on Olena I/O.
+@item image morphology,
+@item watershed algorithms,
+@item Olena I/O.
 @end itemize
 
 @item Nicolas Burrus
 @itemize @minus
-@item for his work on integre,
-@item for his work on Olena I/O,
-@item for his work on the source tree.
+@item integre,
+@item Olena I/O,
+@item source tree.
 @end itemize
 
 @item Niels van Vliet
 @itemize @minus
-@item for his work on color conversion,
-@item for his work on attribute opening and closing algorithms,
-@item for his contributions to document the code,
-@item for his work on histograms.
+@item color conversion,
+@item attribute opening and closing algorithms,
+@item contributions to document the code,
+@item histograms.
 @end itemize
 
 @item Pierre-Yves Strub
 @itemize @minus
-@item for his work on Olena morpho,
-@item for his work on the source tree and configuration system,
-@item for his work on the type system.
+@item Olena morpho,
+@item source tree and configuration system,
+@item type system.
 @end itemize
 
 @item Qu@^oc Peyrot
-for his work on the watershed algorithm.
+@itemize @minus
+@item watershed algorithm.
+@end itemize
 
 @item Rapha@"el Poss
 @itemize @minus
-@item for his work on the source tree and configuration system,
-@item for his work on the documentation.
+@item source tree and configuration system,
+@item documentation.
 @end itemize
 
 @item R@'emi Coupet
 @itemize @minus
-@item for his work on Olena morpho,
-@item for his work on data types (pre-0.6),
-@item for his work on the Olena core,
-@item for his bibliographic research.
+@item Olena morpho,
+@item data types (pre-0.6),
+@item Olena core,
+@item bibliographic research.
 @end itemize
 
 @item Renaud Fran@,cois
-for his bibliographic research.
+@itemize @minus
+@item bibliographic research.
+@end itemize
 
 @item Simon Odou
 @itemize @minus
-@item for his contributions to document the code,
-@item for his work on generic morphers.
+@item contributions to document the code,
+@item generic morphers.
 @end itemize
 
 @item Sylvain Berlemont
 @itemize @minus
-@item for his work on combinatorial maps,
-@item for his contributions to cleanup the sources.
+@item combinatorial maps,
+@item cleanup the sources.
 @end itemize
 
 @item Yann R@'egis-Gianas
 @itemize @minus
-@item for his work on the type system,
-@item for his work on graphs,
-@item for his numerous contributions to various parts of Olena.
+@item type system.
 @end itemize
 
 @item Yoann Fabre
-for his work on the type system.
+@itemize @minus
+@item type system.
+@end itemize
+
 
 @item Vincent Berruchon
 
Index: doc/dev/abstract.texi
--- doc/dev/abstract.texi Thu, 15 Apr 2004 18:13:03 +0200 thivol_d (oln/p/41_abstract.t 1.7.1.3 600)
+++ doc/dev/abstract.texi Wed, 12 May 2004 10:43:17 +0200 reda (oln/p/41_abstract.t 1.7.1.3 600)
@@ -26,4 +26,4 @@
 or @email{olena-bugs@@lrde.epita.fr}.
 
 Olena also has a web page, located at
-@url{http://www.lrde.epita.fr/cgi-bin/twiki/view/Projects/Olena}.
+@url{http://olena.lrde.epita.fr}.
Index: doc/dev/build.texi
--- doc/dev/build.texi Tue, 20 Apr 2004 18:45:34 +0200 van-vl_n (oln/p/42_build.texi 1.13 600)
+++ doc/dev/build.texi Wed, 12 May 2004 10:49:36 +0200 reda (oln/p/42_build.texi 1.13 600)
@@ -100,7 +100,7 @@
 @item @command{RCC}, @command{xlC_r} or @command{xlC}.
 @end itemize
 
-You can override the detection system by passing your favourite compiler
+You can override the detection system by passing your favorite compiler
 name to @command{configure}, as follows:
 
 @example
@@ -236,7 +236,7 @@
 
 @sp 1
 
-Additionnally, you can build and run the testsuite and demonstration
+Additionally, you can build and run the testsuite and demonstration
 programs with:
 
 @example
Index: doc/dev/install.texi
--- doc/dev/install.texi Fri, 21 Feb 2003 09:41:40 +0100 akim (oln/p/43_install.te 1.3 600)
+++ doc/dev/install.texi Wed, 12 May 2004 10:59:25 +0200 reda (oln/p/43_install.te 1.3 600)
@@ -19,7 +19,7 @@
 
 from the build directory.
 
-If not overriden with @option{--prefix}
+If not overridden with @option{--prefix}
 @ifplaintext
 (see the BUILD file)
 @end ifplaintext
Index: doc/dev/faq.texi
--- doc/dev/faq.texi Thu, 15 Apr 2004 19:31:21 +0200 thivol_d (oln/p/44_faq.texi 1.11 600)
+++ doc/dev/faq.texi Wed, 12 May 2004 10:58:49 +0200 reda (oln/p/44_faq.texi 1.11 600)
@@ -25,7 +25,7 @@
 Answer 1: run the toplevel configure with the @option{--without-doc} option.
 
 Answer 2: if you do not want to build the reference manuals but still
-compile the demonstraction programs and developer's info files, use
+compile the demonstration programs and developer's info files, use
 @option{--without-doc-ref}.
 
 @section Using Olena
@@ -60,7 +60,7 @@
 @cindex @file{oln-config.sh}
 
 Answer 3: use the generated @command{oln-config-xxx.sh}, substituting
-@samp{xxx} with your favourite compiler. This script dumps to its
+@samp{xxx} with your favorite compiler. This script dumps to its
 standard output the flags necessary to build programs that use Olena
 successfully with the corresponding compiler. Use the @option{--help}
 flag to see what data is available.
@@ -97,7 +97,7 @@
 are weird and/or inaccurate.
 
 @item Explanation 1
-You are using GCC 2.95 and heavy optimisation
+You are using GCC 2.95 and heavy optimization
 (@option{-O3}) flags.  This is known to produce invalid code with Olena.
 
 @item Solution 1
Index: doc/dev/srctree.texi
--- doc/dev/srctree.texi Thu, 15 Apr 2004 18:09:53 +0200 palma_g (oln/p/45_srctree.te 1.7 600)
+++ doc/dev/srctree.texi Wed, 12 May 2004 11:03:22 +0200 reda (oln/p/45_srctree.te 1.7 600)
@@ -1,7 +1,7 @@
 @node The Olena source tree
 @chapter The Olena source tree
 
-The Olena source tree is divided into several distrinct components:
+The Olena source tree is divided into several distinct components:
 
 @table @file
 @item top source directory
Index: doc/dev/conf.texi
--- doc/dev/conf.texi Wed, 09 Apr 2003 22:31:55 +0200 burrus_n (oln/q/2_conf.texi 1.4 600)
+++ doc/dev/conf.texi Wed, 12 May 2004 10:56:14 +0200 reda (oln/q/2_conf.texi 1.4 600)
@@ -244,7 +244,7 @@
 
 @strong{Rationale for using the C++ compiler} (instead of the C
 compiler): the FFTW library is a C library and there are systems where
-C++ programs cannot link with any C library without options. This ckeck
+C++ programs cannot link with any C library without options. This check
 ensures that faulty link configurations fail early.
 
 @c ************************************************************************
@@ -254,7 +254,7 @@
 @cindex @env{HAVE_ZLIB}
 
 The implementation of the I/O operators in Olena can make use of the
-Zlib library fo save or load images from gzipped files. Because this
+Zlib library to save or load images from gzipped files. Because this
 library might be unavailable, it is only used if the macro
 @env{HAVE_ZLIB} is defined to nonzero, and the correct include path is
 given to the compiler.